import Main from "./main.js";
import Router from "./Router.js";

/* Navigation */

const routes = [
  { path: "/", page: "home" },
  { path: "/play", page: "play" },
  { path: "/map", page: "map" },
];
let router = new Router(routes);

const links = document.querySelectorAll("a");
for (let i = 0; i < links.length; i++) {
  links[i].addEventListener("click", (e) => {
    e.preventDefault();
    router.ChangePages(e.currentTarget.getAttribute("href"));
  });
}

const inputName = document.querySelector(".name");
const slides = document.querySelectorAll(".slide");

let playerCharacter = "goku";
let playerName = "";

inputName.addEventListener("input", (e) => {
  e.preventDefault();
  console.log(e.currentTarget.value);
  playerName = e.currentTarget.value;
});

for (let i = 0; i < slides.length; i++) {
  slides[i].addEventListener("click", (e) => {
    playerCharacter = e.currentTarget.getAttribute("name");
    console.log(playerCharacter);
  });
}

const playPages = document.querySelector(".play");
const startButton = document.querySelector(".start-button");
const map = document.querySelector(".map");

startButton.addEventListener("click", (e) => {
  e.preventDefault();
  playPages.style.display = "none";
  map.style.display = "block";
  if (playerName.length > 0) {
    Main(playerName, playerCharacter);
  }
});
