import express from "express";
import http from "http";
const app = express();
const httpServer = http.createServer(app);
import { Server as IOServer } from "socket.io";

app.use("/", express.static("client/public"));

let users = [];

let sushis = [];
for (let i = 0; i < 1500; i++) {
  sushis.push({ x: Math.random(), y: Math.random() });
}

const io = new IOServer(httpServer);
io.on("connection", (socket) => {
  io.emit("user", socket.id);
  io.emit("sushis", sushis);

  socket.on("newUser", (data) => {
    users.push(data);
    socket.emit("allUsers", users);
  });

  socket.on("updateUser", (data) => {
    for (let i = 0; i < users.length; i++) {
      if (users[i].id === data.id) {
        users[i] = data;
      }
      users.sort((a, b) => a.radius - b.radius);
      socket.emit("allUsers", users);
    }
  });

  socket.on("updateSushi", (data) => {
    sushis.splice(data, 1);
    sushis.push({ x: Math.random(), y: Math.random() });
    io.emit("newSushi", { new: sushis[sushis.length - 1], drop: data });
  });
});

const port = 8000;
httpServer.listen(port, () => {
  console.log(`Think http://localhost:${port}, Think !/`);
});
